/*
 * gaim AOL Instant Messenger Client
 *
 * Copyright (C) 1998-1999, Mark Spencer <markster@marko.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#if (GTK_MINOR_VERSION < 1)
#define OLD_GTK
#else
#undef OLD_GTK
#endif

#ifdef USE_APPLET
#include <applet-widget.h>
#endif /* USE_APPLET */


/*
	1.  gethostbyname();
	2.  connect();
	3.  toc_signon();
	4.  toc_wait_signon();
	5.  toc_wait_config();
	6.  actually done..
*/

#define STATE_FLAPON 1
#define STATE_SIGNON_REQUEST 2
#define STATE_SIGNON_ACK 3
#define STATE_CONFIG 4

#define UC_AOL		1
#define UC_ADMIN 	2
#define UC_UNCONFIRMED	4
#define UC_NORMAL	8

#define WFLAG_SEND 1
#define WFLAG_RECV 2
#define WFLAG_AUTO 4


#define AUTO_RESPONSE "<AUTO-REPLY> : "

struct person {
	char name[80];
	GtkWidget *item;
	GtkWidget *label;
	GtkWidget *pix;
	GtkWidget *idletime;
	int present;
	int evil;
	long signon;
	int idle;
	int uc;
	struct person *next;
};

struct log_conversation {
	char name[80];
	char filename[512];
        struct log_conversation *next;
};

struct buddy_pounce {
        char name[80];
        char message[1024];
        struct buddy_pounce *next;
};

struct away_message {
	char name[80];
	char message[1024];
	struct away_message *next;
};

struct category {
	GtkWidget *item;
        GtkWidget *label;
	GtkWidget *tree;
	char name[80];
	struct person *members;
	struct category *next;
};

struct buddy_chat {
	GtkWidget *window;
	GtkWidget *text;
	GtkWidget *list;
	GtkWidget *entry;
	int makesound;
	int id;
	char name[80];
	struct buddy_chat *next;
};

struct conversation {
        GtkWidget *window;
        char name[80];
#ifdef USE_XMHTML
	GtkWidget *html;
#else
	GtkWidget *text;
#endif
        GtkWidget *entry;
	GtkWidget *italic;
        GtkWidget *bold;
	GtkWidget *palette;
        GtkWidget *add_button;
        GtkWidget *log_button;
        int makesound;
        
        time_t sent_away;
	struct conversation *next;
};



struct sflap_hdr {
	unsigned char ast;
	unsigned char type;
	unsigned short seqno;
	unsigned short len;
};

struct signon {
	unsigned int ver;
	unsigned short tag;
	unsigned short namelen;
	char username[80];
};

#define LOGIN_STEPS 5

#define CONVERSATION_TITLE "Gaim - Conversation with %s"
#define LOG_CONVERSATION_TITLE "Gaim - Conversation with %s (logged)"


/* These should all be runtime selectable */

#define TOC_HOST "toc.oscar.aol.com"
#define TOC_PORT 9898
#define AUTH_HOST "login.oscar.aol.com"
#define AUTH_PORT 5190
#define LANGUAGE "english"

#define BUF_LEN 1024
#define BUF_LONG BUF_LEN * 2


#define TYPE_SIGNON    1  
#define TYPE_DATA      2
#define TYPE_ERROR     3
#define TYPE_SIGNOFF   4
#define TYPE_KEEPALIVE 5

#undef EXACT

#ifdef EXACT
#define REVISION "TIK:$Revision: 1.68 $"
#define FLAPON "FLAPON\r\r\n\r\r\nFLAPON\r\r\n\r\r\n"
#else
#define REVISION "gaim:$Revision: 1.68 $"
#define FLAPON "FLAPON\r\n\r\n"
#endif

#define ROAST "Tic/Toc"

#define STYLE_ITALIC 0x01000000
#define STYLE_BOLD 0x020000000

#define FIXED_FONT "-*-courier-medium-r-*-*-*-%d-*-*-*-*-*-*"
#define FIXED_BOLD_FONT "-*-courier-bold-r-*-*-*-%d-*-*-*-*-*-*"
#define FIXED_ITALIC_FONT "-*-courier-medium-o-*-*-*-%d-*-*-*-*-*-*"
#define FIXED_BOLD_ITALIC_FONT "-*-courier-bold-o-*-*-*-%d-*-*-*-*-*-*"
#define PROP_FONT "-*-helvetica-medium-r-*-*-*-%d-*-*-*-*-*-*"
#define PROP_BOLD_FONT "-*-helvetica-bold-r-*-*-*-%d-*-*-*-*-*-*"
#define PROP_ITALIC_FONT "-*-helvetica-medium-o-*-*-*-%d-*-*-*-*-*-*"
#define PROP_BOLD_ITALIC_FONT "-*-helvetica-bold-o-*-*-*-%d-*-*-*-*-*-*"

#define BUDDY_ARRIVE 0
#define BUDDY_LEAVE 1
#define SEND 2
#define RECEIVE 3




#ifdef USE_APPLET
extern GtkWidget *applet;
#endif /* USE_APPLET */


extern GList *permit;  /* The list of people permitted */
extern GList *deny;    /* The list of people denies */

extern char *quad_addr;
extern struct conversation *cnvroot;
extern struct buddy_chat *chatroot;
extern struct away_message *awaymessage;
extern struct buddy_pounce *bproot;
extern struct log_conversation *logroot;
extern int permdeny;
extern char toc_addy[];
extern GtkWidget *awaymess;
extern GtkWidget *blist;
extern GtkWidget *awaymenu;
extern GtkWidget *bpmenu;

/* SAVED */
extern int sounds;
extern int extrasounds;
extern int enter_sends;
extern int show_time;
extern int show_cat_nums;
extern int remember_pass;
extern int ignore_colours;
extern int showidle;
extern int popup_windows;
extern int button_pix;
extern int showpix;
extern int auto_login;
extern char ourname[];
extern char mypassword[];

extern struct away_message *awayroot;




/* Functions in about.c */
extern void show_about(GtkWidget *, void *);



/* Functions in buddy_chat.c */
extern void join_chat();
extern void chat_write(struct buddy_chat *, char *, int, char *);
extern void add_chat_buddy(struct buddy_chat *, char *);
extern void remove_chat_buddy(struct buddy_chat *, char *);
extern void show_new_buddy_chat(struct buddy_chat *);



/* Functions in html.c */
#ifdef USE_GHTTP
extern void new_show_html(GtkWidget *, char *);
#endif /* USE_GHTTP */
#ifdef USE_XMHTML
extern void html_write(GtkWidget *, char *);
extern void html_update(GtkWidget *);
#else
extern void html_print(GtkWidget *, char *);
#endif
extern GdkFont *getfont(int, int, int, int);
extern void show_html(GtkWidget *, char *);
extern char *fix_url(char *);

/* Functions in conversation.c */
extern void write_to_conv(GtkWidget *, char *, char *, int);
extern void conv_write(struct conversation *, char *, char *);
extern void show_conv(struct conversation *);
extern struct conversation *new_conversation(char *);
extern struct conversation *find_conversation(char *);
extern void delete_conversation(struct conversation *);
extern int is_logging(char *);
extern void set_state_lock(int );

/* Functions in toc.c */
extern char *condense(char *);
extern unsigned int *get_address(char *);
extern void toc_close();
extern int connect_address(unsigned int, unsigned short);
extern int toc_signon(char *, char *);
extern int toc_wait_signon(void);
extern char *toc_wait_config(void);
extern int sflap_send(char *, int , int );
extern int escape_text(char *);

/* Functions in buddy.c */
extern void destroy_buddy();
extern void update_num_categories();
extern void update_show_idlepix();
extern void update_button_pix();
extern void show_buddy_list(char *);
extern void build_config(char *, int len);
extern void signoff();
extern void do_im_back();
extern void parse_buddy_list(char *, int);
extern void set_buddy(struct person *);
extern struct person *get_person(char *);
extern int add_person(char *, char *);
extern void add_category(char *);
extern void build_edit_tree();
extern void build_permit_tree();
extern void remove_person(char *, char *);
extern void remove_category(char *);
extern void do_pounce(char *);
extern void do_bp_menu();
extern int is_buddy(char *);
extern struct category *find_category(char *);

/* Functions in away.c */
extern void show_away_mess();
extern void do_away_message(GtkWidget *, struct away_message *);
extern void do_away_menu();

/* Functions in aim.c */
extern void aol_icon(GdkWindow *);
extern void hide_progress(char *);
extern void display_login();
#ifdef USE_APPLET
extern void make_buddy();
extern void applet_show_login(AppletWidget *, gpointer);
#endif


/* Functions in sound.c */
extern void play_sound(int);


/* Functions in prefs.c */
extern void set_option(GtkWidget *, int *);
extern void load_prefs();
extern void save_prefs();
extern void show_prefs();


/* Functions in dialogs.c */
extern void show_warn_dialog(char *);
extern void show_error_dialog(char *);
extern void show_im_dialog(GtkWidget *, GtkWidget *);
extern void show_add_buddy(char *, char *);
extern void show_add_perm();
extern void destroy_all_dialogs();
extern void show_export_dialog();
extern void show_import_dialog();
extern void show_new_bp();
extern void show_log_dialog(char *);

