/*
 * gaim AOL Instant Messenger Client
 *
 * Copyright (C) 1998-1999, Mark Spencer <markster@marko.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <string.h>
#include <sys/time.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "aim.h"

GtkWidget *prefs=NULL;
int sounds;
int extrasounds;
int enter_sends;
int show_time;
int remember_pass;
int auto_login;
int showpix;
int popup_windows;
int ignore_colours;
int button_pix;
int permdeny;
int showidle;
int show_cat_nums;
char ourname[80];
char mypassword[16];
struct away_message *awayroot;
struct log_conversation *l;
struct log_conversation *logroot;

void load_prefs()
{
	FILE *f;
	struct away_message *a, *b;
	struct log_conversation *ll;

	char *tmp;
	char *tmp2;
	char buf[BUF_LONG];

	tmp = g_malloc(256);  /* Have to allocate memory to pointers */
        tmp2 = g_malloc(256);

	awayroot = NULL;
	logroot = NULL; 

	/* Defaults.  If these are in the .gaimrc they'll be overwritten. */
	sounds = 1;
	extrasounds = 1;
	showidle = 1;
	enter_sends = 1;
	show_time = 1;
        showpix = 1;
        button_pix = 1;
	
	if (getenv("HOME")) {
		g_snprintf(buf, sizeof(buf), "%s/.gaimrc", getenv("HOME"));
		if ((f = fopen(buf,"r"))) {
			while(fgets(buf, sizeof(buf), f)>0) {
				if (buf[0] == '#')
					continue;
                                sscanf(buf, "%s %[A-Za-z =0-9!@#$%%^&*()-]\n", tmp, tmp2);
				
				if (!strcasecmp(tmp, "username")) {
					g_snprintf(ourname, sizeof(ourname), "%s", tmp2);
				} else if (!strcasecmp(tmp, "password")) {
					g_snprintf(mypassword, sizeof(mypassword), "%s", tmp2);
				} else if (!strcasecmp(tmp, "sounds")) {
					sscanf(tmp2, "%d", &sounds);
				} else if (!strcasecmp(tmp, "showpix")) {
					sscanf(tmp2, "%d", &showpix);
				} else if (!strcasecmp(tmp, "extrasounds")) {
					sscanf(tmp2, "%d", &extrasounds);
				} else if (!strcasecmp(tmp, "enter_sends")) {
					sscanf(tmp2, "%d", &enter_sends);
				} else if (!strcasecmp(tmp, "show_time")) {
					sscanf(tmp2, "%d", &show_time);	
				} else if (!strcasecmp(tmp, "remember_pass")) {
					sscanf(tmp2, "%d", &remember_pass);
				} else if (!strcasecmp(tmp, "showidle")) {
					sscanf(tmp2, "%d", &showidle);
				} else if (!strcasecmp(tmp, "button_pix")) {
					sscanf(tmp2, "%d", &button_pix);
                                } else if (!strcasecmp(tmp, "auto_login")) {
                                        sscanf(tmp2, "%d", &auto_login);
                                } else if (!strcasecmp(tmp, "show_cat_nums")) {
                                        sscanf(tmp2, "%d", &show_cat_nums);
                                } else if (!strcasecmp(tmp, "ignore_colours")) {
                                        sscanf(tmp2, "%d", &ignore_colours);
                                } else if (!strcasecmp(tmp, "popup_windows")) {
                                        sscanf(tmp2, "%d", &popup_windows);
				} else if (!strcasecmp(tmp, "away_mess")) {
					fgets(buf, sizeof(buf), f);
					if (!strlen(buf) || !strlen(tmp2))
						continue;
					a = (struct away_message *)g_new(struct away_message, 1);
					g_snprintf(a->name, sizeof(a->name), "%s", tmp2);
					g_snprintf(a->message, sizeof(a->message), "%s", buf);
					/* Get rid of the \n ya doofus */
					a->message[strlen(a->message) - 1] = '\0';
					a->next = NULL;
					if (awayroot == NULL)
						awayroot = a;
					else
						b->next = a;
					b = a;
				} else
				if (!strcasecmp(tmp, "log_name")) {
					fgets(buf, sizeof(buf), f);
					if (!strlen(buf) || !strlen(tmp2))
						continue;
					l = (struct log_conversation *)g_new(struct log_conversation, 1);
					g_snprintf(l->name, sizeof(l->name), "%s", tmp2);
					g_snprintf(l->filename, sizeof(l->filename), "%s", buf);

					l->filename[strlen(l->filename) - 1] = '\0';
					l->next = NULL;
					if (logroot == NULL)
						logroot = l;
					else
						ll->next = l;
					ll = l;
#ifdef DEBUG
					printf("Logging: %s\n", l->name);
#endif
				}
			}
			fclose(f);
		}
	}
	

       g_free(tmp);
       g_free(tmp2);
}

void save_prefs()
{
	FILE *f;
	struct away_message *a;

	char buf[BUF_LONG];
	if (getenv("HOME")) {
		g_snprintf(buf, sizeof(buf), "%s/.gaimrc", getenv("HOME"));
		if ((f = fopen(buf,"w"))) {
			fprintf(f, "username %s\n", ourname);
			if (remember_pass) {
				fprintf(f, "password %s\n",mypassword);
			} else {
				fprintf(f, "password none\n");
			}
			fprintf(f, "sounds %d\n", sounds);
			fprintf(f, "extrasounds %d\n", extrasounds);
			fprintf(f, "enter_sends %d\n", enter_sends);
			fprintf(f, "show_time %d\n", show_time);
			fprintf(f, "remember_pass %d\n", remember_pass);
			fprintf(f, "auto_login %d\n", auto_login);
			fprintf(f, "showidle %d\n", showidle);
			fprintf(f, "ignore_colours %d\n", ignore_colours);
			fprintf(f, "showpix %d\n", showpix);
			fprintf(f, "button_pix %d\n", button_pix);
                        fprintf(f, "popup_windows %d\n", popup_windows);
			fprintf(f, "show_cat_nums %d\n", show_cat_nums);
			a = awayroot;
			while(a != NULL) {
				fprintf(f, "away_mess %s\n", a->name);
				fprintf(f, "%s\n", a->message);
				a=a->next;
                        }
			l = logroot;
			while(l != NULL) {
				fprintf(f, "log_name %s\n", l->name);
				fprintf(f, "%s\n", l->filename);
				l=l->next;
			}
                        fclose(f);
                        chmod(buf, S_IRUSR | S_IWUSR);
                }
                
	}
}

void set_option(GtkWidget *w, int *data)
{
        *data = !(*data);
        if (data == &show_cat_nums)
		update_num_categories();
	if (data == &showidle || data == &showpix)
		update_show_idlepix();
	if (data == &button_pix)
		update_button_pix();
	save_prefs();
#if 0
	printf("Data %p set to %d\n",data, *data);
#endif
}

static void set_permit(GtkWidget *w, int *data)
{
        char buf[BUF_LONG];
	permdeny = (int)data;
//	printf("BLAH BLAH %d %d", permdeny, (int) data);
	/* We don't save this 'at home', it's on the server.
	 * So, we gotta resend the config to the server. */
	build_config(buf, sizeof(buf)/2);
	sflap_send(buf, -1, TYPE_DATA);
	      

}

static void handle_delete()
{
	gtk_widget_hide(prefs);
}

void build_prefs()
{
	GtkWidget *bbox;
	GtkWidget *vbox;
	GtkWidget *close;
	GtkWidget *sound;
	GtkWidget *extra;
	GtkWidget *enter;
	GtkWidget *time;
	GtkWidget *show_idle, *show_pix;
	GtkWidget *button_pix_button;
        GtkWidget *ignore_colours_button;
        GtkWidget *autolog;
        GtkWidget *shownum;
        GtkWidget *popup;
	GtkWidget *notebook;
	GtkWidget *general_page;
	GtkWidget *sound_page;
	GtkWidget *appearance_page;
        GtkWidget *colour_page;
	GtkWidget *permdeny_page;
	GtkWidget *label;
        GtkWidget *permopt;
        
	/* Notebooks */
	notebook = gtk_notebook_new();

        /* General */
	general_page = gtk_vbox_new(FALSE, 0);
	label = gtk_label_new("General");
	gtk_widget_show(label);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), general_page, label);
     	enter = gtk_check_button_new_with_label("Enter sends message");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enter), enter_sends);
	autolog = gtk_check_button_new_with_label("Auto-Login");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(autolog),auto_login);
        popup = gtk_check_button_new_with_label("Raise windows when message recieved");
        gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(popup), popup_windows);
        gtk_box_pack_start(GTK_BOX(general_page), enter, FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(general_page), autolog, FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(general_page), popup, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(enter), "clicked", GTK_SIGNAL_FUNC(set_option), &enter_sends);
        gtk_signal_connect(GTK_OBJECT(autolog), "clicked", GTK_SIGNAL_FUNC(set_option), &auto_login);
        gtk_signal_connect(GTK_OBJECT(popup), "clicked", GTK_SIGNAL_FUNC(set_option), &popup_windows);
        gtk_widget_show(general_page);
        gtk_widget_show(popup);
	gtk_widget_show(enter);
	gtk_widget_show(autolog);

	/* Sound */
	sound_page = gtk_vbox_new(FALSE, 0);
	label = gtk_label_new("Sounds");
	gtk_widget_show(label);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), sound_page, label);
	sound = gtk_check_button_new_with_label("Enable buddy logon/logoff sounds");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(sound), sounds);
	extra = gtk_check_button_new_with_label("Enable send/receive message sounds");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(extra), extrasounds);
	gtk_box_pack_start(GTK_BOX(sound_page), sound, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(sound_page), extra, FALSE, FALSE, 0);
	gtk_signal_connect(GTK_OBJECT(sound), "clicked", GTK_SIGNAL_FUNC(set_option), &sounds);
	gtk_signal_connect(GTK_OBJECT(extra), "clicked", GTK_SIGNAL_FUNC(set_option), &extrasounds);
	gtk_widget_show(sound_page);
	gtk_widget_show(sound);
	gtk_widget_show(extra);


	/* Appearance */
	appearance_page = gtk_vbox_new(FALSE, 0);
        label = gtk_label_new("Appearance");
        gtk_widget_show(label);
        gtk_notebook_append_page(GTK_NOTEBOOK(notebook), appearance_page, label);
	time = gtk_check_button_new_with_label("Show time on messages");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(time), show_time);
        shownum = gtk_check_button_new_with_label("Show numbers in groups");
        gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(shownum), show_cat_nums);
	show_pix = gtk_check_button_new_with_label("Show buddy-type pixmaps");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(show_pix), showpix);
        show_idle = gtk_check_button_new_with_label("Show idle times");
        gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(show_idle), showidle);
	button_pix_button = gtk_check_button_new_with_label("Show button pixmaps");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button_pix_button), button_pix);

	
	gtk_box_pack_start(GTK_BOX(appearance_page), time, FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(appearance_page), shownum, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(appearance_page), show_pix, FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(appearance_page), show_idle, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(appearance_page), button_pix_button, FALSE, FALSE, 0);

	gtk_signal_connect(GTK_OBJECT(time), "clicked", GTK_SIGNAL_FUNC(set_option), &show_time);
        gtk_signal_connect(GTK_OBJECT(shownum), "clicked", GTK_SIGNAL_FUNC(set_option), &show_cat_nums);
	gtk_signal_connect(GTK_OBJECT(show_pix), "clicked", GTK_SIGNAL_FUNC(set_option), &showpix);
        gtk_signal_connect(GTK_OBJECT(show_idle), "clicked", GTK_SIGNAL_FUNC(set_option), &showidle);
        gtk_signal_connect(GTK_OBJECT(button_pix_button), "clicked", GTK_SIGNAL_FUNC(set_option), &button_pix);
	
	gtk_widget_show(shownum);
	gtk_widget_show(time);
	gtk_widget_show(show_idle);
	gtk_widget_show(show_pix);
        gtk_widget_show(button_pix_button);
	gtk_widget_show(appearance_page);
	


	/* Colours */
	colour_page = gtk_vbox_new(FALSE, 0);
	label = gtk_label_new("Colour");
	gtk_widget_show(label);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), colour_page, label);
	
	ignore_colours_button = gtk_check_button_new_with_label("Ignore incoming colours, always use default");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ignore_colours_button), ignore_colours);
	gtk_box_pack_start(GTK_BOX(colour_page), ignore_colours_button, FALSE, FALSE, 0);

	gtk_signal_connect(GTK_OBJECT(ignore_colours_button), "clicked", GTK_SIGNAL_FUNC(set_option), &ignore_colours);

	gtk_widget_show(ignore_colours_button);
        gtk_widget_show(colour_page);
	
	/* Perm/Deny */
        permdeny_page = gtk_vbox_new(FALSE, 0);
        label = gtk_label_new("Permit/Deny");
        gtk_widget_show(label);
        gtk_notebook_append_page(GTK_NOTEBOOK(notebook), permdeny_page, label);

        permopt = gtk_radio_button_new_with_label(NULL, "Allow anyone to contact me");
        gtk_box_pack_start(GTK_BOX(permdeny_page), permopt, FALSE, FALSE, 0);
        gtk_signal_connect(GTK_OBJECT(permopt), "clicked", GTK_SIGNAL_FUNC(set_permit), (void *)1);
	gtk_widget_show(permopt);
	if (permdeny == 1)
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(permopt), TRUE);

        permopt = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(permopt)), "Permit only people in Permit group");
        gtk_box_pack_start(GTK_BOX(permdeny_page), permopt, FALSE, FALSE, 0);
        gtk_signal_connect(GTK_OBJECT(permopt), "clicked", GTK_SIGNAL_FUNC(set_permit), (void *)3);
	gtk_widget_show(permopt);
	if (permdeny == 3)
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(permopt), TRUE);


        permopt = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(permopt)), "Permit all except those in Deny group");
        gtk_box_pack_start(GTK_BOX(permdeny_page), permopt, FALSE, FALSE, 0);
        gtk_signal_connect(GTK_OBJECT(permopt), "clicked", GTK_SIGNAL_FUNC(set_permit), (void *)4);
        gtk_widget_show(permopt);
	if (permdeny == 4)
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(permopt), TRUE);

        gtk_widget_show(permdeny_page);
        
	
	vbox = gtk_vbox_new(FALSE, 5);
	bbox = gtk_hbox_new(FALSE, 5);
	close = gtk_button_new_with_label("Close");
	
	/* Pack the button(s) in the button box */
	gtk_box_pack_end(GTK_BOX(bbox), close, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(vbox), notebook, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(vbox),bbox, FALSE, FALSE, 5);

	gtk_widget_show(notebook);
        gtk_widget_show(close);

	gtk_widget_show(bbox);
        gtk_widget_show(vbox);

	prefs = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_realize(prefs);
	aol_icon(prefs->window);
	gtk_container_add(GTK_CONTAINER(prefs), vbox);
	gtk_container_border_width(GTK_CONTAINER(prefs), 10);
	gtk_window_set_title(GTK_WINDOW(prefs), "Gaim - Preferences");
	gtk_signal_connect(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(handle_delete), NULL);
	gtk_signal_connect(GTK_OBJECT(prefs),"delete_event", 
		           GTK_SIGNAL_FUNC(handle_delete), NULL);
	
}

void show_prefs()
{
	if (!prefs)
		build_prefs();
	gtk_widget_show(prefs);
}

	
